 /***************************************************************************
                          cdialog.cc  -  The configurations dialog for kacpi
                             -------------------
    begin                : Sa Jun 1  22:22:11 CET 2002
    copyright            : (C) 2002,2003 by Jonas Genannt
    email                : jonasge@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//QT      include:
#include <qtooltip.h>
#include <qmessagebox.h>
//KDE     include:
#include <klocale.h>
#include <kiconloader.h>
#include <kaudioplayer.h>
#include <kconfig.h>
#include <kprocess.h>
//other   include:
#include "confmain.moc"
#include "dock.h"
#include <iostream>

QString swarsound, swarcommand,infofile,statusfile,acfile,version,dock,drawbeam,sbattery2, stemp, tempfile;
int cmp, autotime;

newconf::newconf( QWidget *parent,const char *name,bool modal )
    : QDialog(parent, name,modal)
 {
   QFont fdefault("Helvetica", 10);
   this->resize(423,430); // 423,390
   this->setMinimumSize(0,0);
   this->setCaption(i18n("Settings for Kacpi"));



   confTbs = new QTabWidget(this, "confTbs");
   confTbs->setGeometry(QRect(10,10,400,360));
//   confTbs->setFont(fdefault);

   conf_1 = new QWidget(confTbs, "conf_1");
   conf_1Layout = new QGridLayout( conf_1);
   conf_1Layout->setSpacing( 4 );
   conf_1Layout->setMargin( 7 );
   confTbs->insertTab(conf_1, i18n("General Settings"));

   conf_2 = new QWidget(confTbs, "conf_2");
   conf_2Layout = new QGridLayout( conf_2);
   conf_2Layout->setSpacing( 4 );
   conf_2Layout->setMargin( 7 );
   confTbs->insertTab(conf_2, i18n("Path Setup"));

   conf_3 = new QWidget(confTbs, "conf_3");
   conf_3Layout = new QGridLayout( conf_3);
   conf_3Layout->setSpacing( 4 );
   conf_3Layout->setMargin( 7 );
   confTbs->insertTab(conf_3, i18n("Icon settings"));

   conf_4 = new QWidget(confTbs, "conf_4");
   conf_4Layout = new QGridLayout( conf_4);
   conf_4Layout->setSpacing( 4 );
   conf_4Layout->setMargin( 7 );
   confTbs->insertTab(conf_4, i18n("low warning settings"));

   btndefaults = new QPushButton(i18n("Defaults"), this);
   btndefaults->setGeometry(20,390,90,30);
   connect(btndefaults, SIGNAL(clicked()), this, SLOT(slotdefaults()));

   btncancel = new QPushButton(i18n("Cancel"),this);
   btncancel->setGeometry(320,390,90,30);
   connect(btncancel, SIGNAL(clicked()), this, SLOT(slotcancel()));

   btnapply = new QPushButton(i18n("Apply"), this);
   btnapply->setGeometry(220,390,90,30);
   connect(btnapply, SIGNAL(clicked()), this, SLOT(slotapply()));

   btnok = new QPushButton(i18n("OK"),this);
   btnok->setGeometry(120,390,90,30);
   connect(btnok, SIGNAL(clicked()), this, SLOT(slotok()));



/*
*  General Setup
*=================
*
*/
general = new QGroupBox( i18n("Settings"), conf_1);
general->setGeometry(20,20,350,240);
checkdock = new QCheckBox(i18n("Dock to the Panel ?"), general);
checkdock->setGeometry(20,20,300,30);
checkbattery2 = new QCheckBox(i18n("Second battery available ?"), general);
checkbattery2->setGeometry(20,60,300,30);
connect(checkbattery2, SIGNAL(clicked()), this, SLOT(cbattery2()));
checktemp = new QCheckBox(i18n("Thermal Zone available?"), general);
checktemp->setGeometry(20,140,300,30);
labelcombo = new QLabel( i18n("ACPI Version: "), general);
labelcombo->setGeometry(20,100,100,20);
checkown = new QCheckBox(i18n("Own paths ?"), general);
connect(checkown, SIGNAL(toggled(bool)), this, SLOT(enable(bool)));
QToolTip::add(checkown , i18n("Normally kacpi find the files automaticly\nIf you have problems, then try this option."));
checkown->setGeometry(120,100,100,30);

checkcpufreq = new QCheckBox(i18n("CPU Freq feature"),general);
checkcpufreq->setGeometry(20,180,300,20);
checkcpufreq->hide();

checkicon = new QCheckBox(i18n("Round or Rectangular LED for AC"),general);
checkicon->setGeometry(20,180,350,20);

autoupdate = new QGroupBox(i18n("Autoupdate"), conf_1);
autoupdate->setGeometry(20,265,350,50);//20,235
stime = new QSlider(autoupdate);
stime->setLineStep(10);
stime->setPageStep(10);
stime->setTickInterval(10);
stime->setTickmarks(QSlider::Right);
stime->setGeometry(110,20,230,20);
stime->setMinValue(10);
stime->setMaxValue(240);
stime->setOrientation(Horizontal);
spintime = new QSpinBox(autoupdate);
spintime->setGeometry(20,20,70,20);
spintime->setMinValue(10);
spintime->setMaxValue(240);
spintime->setSuffix(" sec");
connect(stime, SIGNAL(valueChanged(int)),spintime, SLOT(setValue(int)));
connect(spintime, SIGNAL(valueChanged(int)),stime, SLOT(setValue(int)));
connect(stime, SIGNAL(valueChanged(int)),this, SLOT(slotautoupdate()));

/*
*=========================
* Path Setup
*/
gbatstatus = new QGroupBox(i18n("Path to battery state file"),conf_2);
gbatstatus->setGeometry(20,20,350,50);
lbatstatus = new QLineEdit(gbatstatus);
lbatstatus->setGeometry(10,20,240,20);
batstat = new QPushButton(gbatstatus, "PushButton");
QPixmap pix = SmallIcon("fileopen");
batstat->setPixmap(pix);
batstat->setGeometry(270,20,40,20);
connect(batstat, SIGNAL(clicked()), this, SLOT(slotbatstatus()));

gbatinfo = new QGroupBox(i18n("Path to battery info file"),conf_2);
gbatinfo->setGeometry(20,90,350,50);
lbatinfo = new QLineEdit(gbatinfo);
lbatinfo->setGeometry(10,20,240,20);
batinfo = new QPushButton(gbatinfo, "PushButton");
batinfo->setPixmap(pix);
batinfo->setGeometry(270,20,40,20);
connect(batinfo, SIGNAL(clicked()), this, SLOT(slotbatinfo()));

gacstatus = new QGroupBox(i18n("Path to AC state file"),conf_2);
gacstatus->setGeometry(20,160,350,50);
lacstatus = new QLineEdit(gacstatus);
lacstatus->setGeometry(10,20,240,20);
acstatus = new QPushButton(gacstatus, "PushButton");
acstatus->setPixmap(pix);
acstatus->setGeometry(270,20,40,20);
connect(acstatus, SIGNAL(clicked()), this, SLOT(slotacstatus()));

gtempstatus = new QGroupBox(i18n("Path to Thermal file"),conf_2);
gtempstatus->setGeometry(20,220,350,50);
ltempstatus = new QLineEdit(gtempstatus);
ltempstatus->setGeometry(10,20,240,20);
tempstatus = new QPushButton(gtempstatus, "PushButton");
tempstatus->setPixmap(pix);
tempstatus->setGeometry(270,20,40,20);
connect(tempstatus, SIGNAL(clicked()), this, SLOT(slottempstatus()));
connect(checktemp, SIGNAL(toggled(bool)), gtempstatus, SLOT(setEnabled(bool)));
/*
*=====================
* ICON setup:
*/
gicons = new QGroupBox(i18n("Set the Panel Icons"), conf_3);
gicons->setGeometry(20,20,350,140);
bfull = new KIconButton(gicons);
bfull->setGeometry(20,30,90,70);
bcharging = new KIconButton(gicons);
bcharging->setGeometry(130,30,90,70);
bdischarging = new KIconButton(gicons);
bdischarging->setGeometry(240,30,90,70);

linfofull = new QLabel(i18n("Battery full"), gicons);
linfofull->setGeometry(40,110,60,20);
linfocharging = new QLabel(i18n("Battery charging"), gicons);
linfocharging->setGeometry(130,110,90,20);
linfodischarging = new QLabel(i18n("Battery discharging"), gicons);
linfodischarging->setGeometry(240,110,100,20);

gseticon = new QGroupBox(i18n("Icon settings"), conf_3);
gseticon->setGeometry(20,170,350,90);
checkdraw = new QCheckBox(i18n("Draw the left red power beam ?"), gseticon);
checkdraw->setGeometry(20,20,320,20);
QString checkdrawtipp = i18n("You should only check this CheckBox if you");
checkdrawtipp += i18n(" are using the default Kacpi icons.\n");
checkdrawtipp += i18n("Because these icons have a special layout.");
QToolTip::add(checkdraw, i18n(checkdrawtipp));


//=====================================
//      low power warning setings:
//=====================================
checkakwarning = new QCheckBox(i18n("Activate low power warning ?"), conf_4);
checkakwarning->setGeometry(20,20,300,30);
gwarning = new QGroupBox(i18n("Low power settings"), conf_4);
gwarning->setGeometry(20,60,350,260);
checkwarmsg = new QCheckBox(i18n("Warns with a Message Box"),gwarning);
checkwarmsg->setGeometry(20,20,300,30);
checkshutdown = new QCheckBox(i18n("Shutdown PC if power < 5 min"), gwarning);
checkshutdown->setGeometry(20,55,300,30);
checkwarsound = new QCheckBox(i18n("Play Sound"),gwarning);
checkwarsound->setGeometry(20,90,300,30);
btnplaysound = new QPushButton(gwarning, "PushButton");
QPixmap play = SmallIcon("1rightarrow");
btnplaysound->setPixmap(play);
btnplaysound->setGeometry(300,90,40,30);
QToolTip::add(btnplaysound, i18n("Play Sound"));
linesound = new QLineEdit(gwarning);
linesound->setGeometry(40,140,240,30);
btnsound = new QPushButton(gwarning, "PushButton");
btnsound->setPixmap(pix);
btnsound->setGeometry(300,140,40,30);
checkwarcommand = new QCheckBox(i18n("Exec Command"),gwarning);
checkwarcommand->setGeometry(20,180,300,30);
btnexec = new QPushButton(gwarning, "PushButton");
QPixmap exec = SmallIcon("exec");
btnexec->setPixmap(exec);
btnexec->setGeometry(300,180,40,30);
linecommand = new QLineEdit(gwarning);
linecommand->setGeometry(40,220,240,30);
btncommand = new QPushButton(gwarning, "PushButton");
btncommand->setPixmap(pix);
btncommand->setGeometry(300,220,40,30);

connect(checkakwarning, SIGNAL(toggled(bool)), gwarning, SLOT(setEnabled(bool)));
connect(checkwarsound, SIGNAL(toggled(bool)),linesound, SLOT(setEnabled(bool)));
connect(checkwarsound, SIGNAL(toggled(bool)),btnsound, SLOT(setEnabled(bool)));
connect(checkwarsound, SIGNAL(toggled(bool)), btnplaysound, SLOT(setEnabled(bool)));
connect(checkwarcommand, SIGNAL(toggled(bool)),linecommand, SLOT(setEnabled(bool)));
connect(checkwarcommand, SIGNAL(toggled(bool)),btncommand, SLOT(setEnabled(bool)));
connect(checkwarcommand, SIGNAL(toggled(bool)),btnexec, SLOT(setEnabled(bool)));
connect(btnsound, SIGNAL(clicked()), this, SLOT(slotsound()));
connect(btncommand, SIGNAL(clicked()), this, SLOT(slotcommand()));
connect(btnplaysound, SIGNAL(clicked()), this, SLOT(slotplaysound()));
connect(btnexec, SIGNAL(clicked()), this, SLOT(slotexec()));

//read conf:
   KConfig* config = kapp->config();
   config->writeEntry("Update", "0");
   infofile = config->readEntry("InfoFile", "/proc/acpi/battery/BAT0/info");
   statusfile = config->readEntry("StatusFile", "/proc/acpi/battery/BAT0/state");
   acfile = config->readEntry("ACFile","/proc/acpi/ac_adapter/ACAD/state");
   tempfile = config->readEntry("tempfile", "/proc/acpi/thermal_zone/THRM/temperature");
   sfull = config->readEntry("icon_full", "mini_ackacpi.png");
   sdischarging = config->readEntry("icon_discharging", "mini_battkacpi.png");
   scharging = config->readEntry("icon_charging", "mini_aclokacpi.png");
   swarsound = config->readEntry("warsound", "");
   swarcommand = config->readEntry("warcommand", "");
   autotime = config->readNumEntry("Autoupdate",60);

   buffer = config->readBoolEntry("Aown", false); checkown->setChecked(buffer); gacstatus->setEnabled(buffer); gbatstatus->setEnabled(buffer); gbatinfo->setEnabled(buffer);
   buffer = config->readBoolEntry("drawbeam", true);    checkdraw->setChecked(buffer);
   buffer = config->readBoolEntry("dock_panel", true);  checkdock->setChecked(buffer);
   buffer = config->readBoolEntry("Batt2", false);      checkbattery2->setChecked(buffer);
   buffer = config->readBoolEntry("temp", false);       checktemp->setChecked(buffer); gtempstatus->setEnabled(buffer);
   buffer = config->readBoolEntry("waraktive", true);  checkakwarning->setChecked(buffer); gwarning->setEnabled(buffer);
   buffer = config->readBoolEntry("showmsg", true);     checkwarmsg->setChecked(buffer);
   buffer = config->readBoolEntry("playsound", false);  checkwarsound->setChecked(buffer); linesound->setEnabled(buffer); btnsound->setEnabled(buffer); btnplaysound->setEnabled(buffer);
   buffer = config->readBoolEntry("execommand", false); checkwarcommand->setChecked(buffer); linecommand->setEnabled(buffer); btncommand->setEnabled(buffer); btnexec->setEnabled(buffer);
   buffer = config->readBoolEntry("cpu_freq", false); checkcpufreq->setChecked(buffer);
   checkshutdown->setChecked(config->readBoolEntry("shutdownpc", true));
   checkicon->setChecked(config->readBoolEntry("LED", false));
   lbatstatus->setText(statusfile);
   lbatinfo->setText(infofile);
   lacstatus->setText(acfile);
   ltempstatus->setText(tempfile);
   stime->setValue(autotime);
   linesound->setText(swarsound);
   linecommand->setText(swarcommand);

   bfull->setIcon(sfull);
   bdischarging->setIcon(sdischarging);
   bcharging->setIcon(scharging);
}

newconf::~newconf()
{
}

void newconf::slotdefaults()
{
//checkacpi->setChecked(TRUE);
checkown->setChecked(FALSE);
checkcpufreq->setChecked(FALSE);
checkdock->setChecked(FALSE);
checkdraw->setChecked(TRUE);
checktemp->setChecked(FALSE);
checkbattery2->setChecked(FALSE);
checkakwarning->setChecked(TRUE);
checkwarmsg->setChecked(TRUE);
checkwarsound->setChecked(FALSE);
checkwarcommand->setChecked(FALSE);
checkshutdown->setChecked(true);
checkicon->setChecked(TRUE);
lbatstatus->setText("/proc/acpi/battery/BAT1/state");
lbatinfo->setText("/proc/acpi/battery/BAT1/info");
lacstatus->setText("/proc/acpi/ac_adapter/ACAD/state");
ltempstatus->setText("/proc/acpi/thermal_zone/THRM/temperature");
linesound->setText("");
linecommand->setText("");
stime->setValue(60);
bfull->setIcon("mini_ackacpi.png");
bdischarging->setIcon("mini_battkacpi.png");
bcharging->setIcon("mini_aclokacpi.png");
}

void newconf::slotok()
{
slotapply();
close();
}

void newconf::slotcancel()
{
KConfig* config = kapp->config();
config->writeEntry("Update", "1");
config->sync();
close();
}

void newconf::slotapply()
{
KConfig* config = kapp->config();
config->writeEntry("dock_panel", checkdock->isChecked());
config->writeEntry("drawbeam", checkdraw->isChecked());
config->writeEntry("Aown", checkown->isChecked());
config->writeEntry("Autoupdate",stime->value());
config->writeEntry("StatusFile", lbatstatus->text());
config->writeEntry("InfoFile", lbatinfo->text());
config->writeEntry("ACFile", lacstatus->text());
config->writeEntry("icon_full", bfull->icon());
config->writeEntry("icon_discharging", bdischarging->icon());
config->writeEntry("icon_charging", bcharging->icon());
config->writeEntry("Batt2", checkbattery2->isChecked());
config->writeEntry("temp", checktemp->isChecked());
config->writeEntry("tempfile", ltempstatus->text());
config->writeEntry("waraktive", checkakwarning->isChecked());
config->writeEntry("showmsg", checkwarmsg->isChecked());
config->writeEntry("playsound", checkwarsound->isChecked());
config->writeEntry("execommand", checkwarcommand->isChecked());
config->writeEntry("warsound", linesound->text());
config->writeEntry("warcommand", linecommand->text());
config->writeEntry("shutdownpc", checkshutdown->isChecked());
config->writeEntry("cpu_freq", checkcpufreq->isChecked());
config->writeEntry("LED", checkicon->isChecked());

config->writeEntry("Update", "1");
config->sync();
}

void newconf::slotbatstatus()
{
fbatstatus = KFileDialog::getOpenFileName("/proc/acpi", "", this, "Choose a file");
if (!fbatstatus.isEmpty())
 {
  lbatstatus->setText(fbatstatus);
 }
}

void newconf::slotbatinfo()
{
fbatinfo = KFileDialog::getOpenFileName("/proc/acpi", "", this, "Choose a file");
if (!fbatinfo.isEmpty())
 {
  lbatinfo->setText(fbatinfo);
 }
}

void newconf::slotacstatus()
{
facstatus = KFileDialog::getOpenFileName("/proc/acpi", "", this, "Choose a file");
if (!facstatus.isEmpty())
 {
  lacstatus->setText(facstatus);
 }
}

void newconf::slottempstatus()
{
ftempstatus = KFileDialog::getOpenFileName("/proc/acpi", "", this, "Choose a file");
if (!ftempstatus.isEmpty())
 {
  ltempstatus->setText(ftempstatus);
 }
}

void newconf::slotautoupdate()
{
int sliderval, sec, min;
char char_sec[80], char_text[80];
sliderval = stime->value();

if (sliderval >  59 )
 {
  min = sliderval / 60;
  sec = sliderval - (min * 60);
  if (sec < 10 || sec == 0)
   {
    sprintf(char_sec, "0%d", sec);
   }
  else
   {
    sprintf(char_sec, "%d", sec);
   }
 }
else
 {
  min = 0;
  sprintf(char_sec, "%d", sliderval);
 }
sprintf(char_text, i18n("Autoupdate all 0%d:%s min"), min, char_sec);
autoupdate->setTitle(char_text);
}


void newconf::slotsound()
{
QString sound = KFileDialog::getOpenFileName("", "", this, "Choose a file");
if (!sound.isEmpty())
 {
  linesound->setText(sound);
 }
}

void newconf::slotcommand()
{
QString command = KFileDialog::getOpenFileName("/usr/bin", "", this, "Choose a program");
if (!command.isEmpty())
 {
  linecommand->setText(command);
 }
}

void newconf::slotplaysound()
{
 QString soundplay = linesound->text();
 if (!soundplay.isEmpty())
  {
   KAudioPlayer::play(soundplay);
  }
  else
  {
  QString error = i18n("You must set a file.");
  QMessageBox::warning(this, i18n("Kacpi - Error"), error);
  }
}


void newconf::slotexec()
{

  QString exec = linecommand->text();
  KProcess command;
  command << exec;
  if (!command.start(KProcess::DontCare))
    {
   static QMessageBox cne_mb("Critical", i18n("Sorry, the program that I should start for you failed to start!"),QMessageBox::Critical,QMessageBox::Ok|QMessageBox::Default,QMessageBox::NoButton,QMessageBox::NoButton, this, "newconf", true);
   cne_mb.show();
     } 

}


// wird aufgerufen, wenn CheckBox "Eigene Pfade " angeklicked wird.
void  newconf::enable(bool status)
{
gbatinfo->setEnabled(status);
gbatstatus->setEnabled(status);
gacstatus->setEnabled(status);
}

// verndere die icons, wenn Checkbox 2 gedrckt wird.
void newconf::cbattery2()
 {
  if (checkbattery2->isChecked())
   {
     bfull->setIcon("mini_ackacpi2.png");
     bdischarging->setIcon("mini_battkacpi2.png");
     bcharging->setIcon("mini_aclokacpi2.png");
   }
   else
    {
      bfull->setIcon("mini_ackacpi.png");
      bdischarging->setIcon("mini_battkacpi.png");
      bcharging->setIcon("mini_aclokacpi.png");
    }

 }
 
 
 




