/***************************************************************************
                          kacpi.cpp  -  description
                             -------------------
    begin                : Fri Mar 29 22:22:11 CET 2002
    copyright            : (C) 2002,2003 by Jonas Genannt
    email                : jonasge@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//QT include:
#include <qtimer.h>
#include <qtooltip.h>
#include <qregexp.h>
//KDE include:
#include <kaudioplayer.h>
#include <kprocess.h>
//other include:
#include <iostream>
#include <iterator>
#include <string>
#include <sstream>
#include <fstream>
#include <map>
#include <cstdlib>

#include "dock.h"
#include "kacpi.moc"
#include "confmain.h"
#include "procviewer.h"



using namespace std;
static bool canceled=false;
static bool realclosing=false;
unsigned int oldcuse = 0;
int oldstatecpu=0;
kacpi::kacpi() : KMainWindow()
{
QFont fdefault("Helvetia", 12);
QString sthermal;
 ifstream test_acpi_info("/proc/acpi/info");
 if(!test_acpi_info)
{
 cerr << "\nThis PC does not support ACPI!\nPlease first install a Kernel with ACPI support!\n"<< endl;
 exit(-1);
}
test_acpi_info.close();
 ksdock = new DockWidget(this);
setCaption(i18n("Kacpi Battery State"));

// ob erstes mal gestartet.
KConfig* config = kapp->config();
 if (config->readNumEntry("Kacpi", 0) != 636  )
   {
    config->writeEntry("Kacpi", "636");
    config->writeEntry("Update", "0");
    config->sync();
    QMessageBox::warning(this,i18n("Kacpi configuration"), i18n("Warning !\nKacpi configuration has changed\nPlease check the options.\n"));
    newconf *dlg = new newconf;
    dlg->show();
   }
  kbar = statusBar();
  kbar->insertItem("", 0,2);

 file = new KPopupMenu();
 file->insertItem(SmallIcon("viewmag"), i18n("&Proc Viewer"), this, SLOT(slotproc()));
 file->insertSeparator();
 file->insertItem(SmallIcon("configure"), i18n("&Settings"), this, SLOT(slotnewconf()));
 file->insertSeparator();
 file->insertItem(SmallIcon("exit"), i18n("&Quit"), this, SLOT(slotExit()));
 help = helpMenu();
 menu = menuBar();
 menu->insertItem(i18n("&File"), file);
 menu->insertItem(i18n("&Help"), help);


batteryTBS = new QTabWidget(this, "batteryTBS");
batteryTBS->setFont(fdefault);
batteryTBS->setGeometry(QRect(20,50,360,290));
btab_[1] = new QWidget(batteryTBS, "btab_1");
btab_1Layout = new QGridLayout( btab_[1]);
btab_1Layout->setSpacing( 4 );
btab_1Layout->setMargin( 7 );
batteryTBS->insertTab(btab_[1], i18n("Battery 1"));
btab_[2] = new QWidget(batteryTBS, "btab_2");
btab_2Layout = new QGridLayout( btab_[2]);
btab_2Layout->setSpacing( 4 );
btab_2Layout->setMargin( 7 );
batteryTBS->insertTab(btab_[2], i18n("Battery 2"));
btab_[3] = new QWidget(batteryTBS, "btab_3");
btab_3Layout = new QGridLayout( btab_[3]);
btab_3Layout->setSpacing( 4 );
btab_3Layout->setMargin( 7 );
batteryTBS->insertTab(btab_[3], i18n("CPU"));

//======== CPU teile erzeugen:
lacpu = new QLabel(i18n("CPU:"), btab_[3]);
lacpu->setGeometry(10,20,130,20);
lacpuload = new QLabel(i18n("CPU Load:"), btab_[3]);
lacpuload->setGeometry(10,60,130,20);
lacpuspset = new QLabel(i18n("CPU Speed Step:"),btab_[3]);
lacpuspset->setGeometry(10,100,130,20);
lacputemp = new QLabel(i18n("CPU Temp:"), btab_[3]);
lacputemp->setGeometry(10,140,130,20);
lacputhstate = new QLabel(i18n("Fan State:"), btab_[3]);
lacputhstate->setGeometry(10,180,130,20);

licpu = new QLineEdit("", btab_[3]);
licpu->setGeometry(150,20,190,20);
lcdcpuload = new QLCDNumber(btab_[3]);
lcdcpuload->setGeometry(230,60,70,20);
licpuspset = new QLineEdit("", btab_[3]);
licpuspset->setGeometry(150,100,190,20);
licputemp = new QLineEdit("", btab_[3]);
licputemp->setGeometry(150,140,190,20);
licputhstate = new QLineEdit("", btab_[3]);
licputhstate->setGeometry(150,180,190,20);


//======== CPU Teile erzeugen ENDE

// ENDE CPU


//=================
//Batterieteile erzuegen.... ANfang
//=============
for (int i=0;i<2;i++)
 {
labstatus_[i] = new QLabel(i18n("State:"),btab_[i+1]);
labstatus_[i]->setFont(fdefault);
labstatus_[i]->setGeometry(10,20,120,30);
linestatus_[i] = new QLineEdit("", btab_[i+1]);
linestatus_[i]->setFont(fdefault);
linestatus_[i]->setGeometry(140,20,200,30);

labtime_[i] = new QLabel(i18n("Time:"),btab_[i+1]);
labtime_[i]->setFont(fdefault);
labtime_[i]->setGeometry(10,80,120,30);
linetime_[i] = new QLineEdit("", btab_[i+1]);
linetime_[i]->setFont(fdefault);
linetime_[i]->setGeometry(140,80,200,30);

labptime_[i] = new QLabel(i18n("Powerstate:"),btab_[i+1]);
labptime_[i]->setFont(fdefault);
labptime_[i]->setGeometry(10,140,120,30);
lcdnumber_[i] = new QLCDNumber(4,btab_[i+1]);
lcdnumber_[i]->setGeometry(220,140,90,30);
lcdnumber_[i]->setFont(fdefault);
lcdnumber_[i]->setSegmentStyle(QLCDNumber::Flat);
lcdnumber_[i]->setFrameShadow(QLCDNumber::Sunken);
labpertime_[i] = new QLabel("%", btab_[i+1]);
labpertime_[i]->setFont(QFont("Helvetica",18));
labpertime_[i]->setGeometry(320,140,20,30);

labacstatus_[i] = new QLabel(i18n("AC-Adapter:"),btab_[i+1]);
labacstatus_[i]->setFont(fdefault);
labacstatus_[i]->setGeometry(10,200,120,30);

} // for-schleife

ledac_1 = new KLed(btab_[1]);
ledac_1->setGeometry(310,200,30,30);
ledac_1->setColor(red);
ledac_1->setLook(KLed::Sunken);
if ((config->readBoolEntry("LED",true))) // 1== Rectangular
 {
 ledac_1->setShape(KLed::Rectangular);
 }
else
 {
  ledac_1->setShape(KLed::Circular);
  }
ledac_2 = new KLed(btab_[2]);
ledac_2->setGeometry(310,200,30,30);
ledac_2->setColor(red);
ledac_2->setLook(KLed::Sunken);
if ((config->readBoolEntry("LED",true))) // 1== Rectangular
 {
 ledac_2->setShape(KLed::Rectangular);
 }
else
 {
  ledac_2->setShape(KLed::Circular);
  }


// ==============
//  BatterieTeile erzeugen ende
// ==============

btnupdate = new QPushButton(i18n("&Reload"),this);
btnupdate->setGeometry(20,360,360,40);
btnupdate->setFont(fdefault);
connect(btnupdate, SIGNAL(clicked()), this, SLOT(slotreload()));

checkforcpu(); // test
if ((config->readNumEntry("CPU_FREQ", 0))==1)
 {
  slotcputimer();
 }
slottimer2();
}



//=============================================================================
//=============================================================================
//                          Update slot for  Battery
//=============================================================================
//=============================================================================
void kacpi::slotbattery_1(int battery)
{
bool ac_status=true;
bool battery_state=false;
map<string, string> acpi_f;
map<string, string> bat_state_f;
map<string, string> bat_info_f;
map<string, string> ac_f;
string zeile;
int acpi_ver=0;
string key;
string value;
const  char *fbat_state="";
const  char *fbat_info="";
const  char  *fac_state="";
double ladestatus_double=0;
double laufzeit_double=0;
int sec=0, hour=0, minn=0, hoehe=0, beam=0;
char  char_laufzeit[80];
char_laufzeit[0]='\0';
QString facstate;
QString fbatstate;
QString fbatinfo;
  char* ac_state_strs[][2]={{"/proc/acpi", "State"}, {"/proc", "state"}};

  char* batt_info_strs[][14]=
    {{"/proc/acpi/battery/BAT0/info", "Present", "Design Capacity", "Last Full Capacity",
      "Battery Technology", "Design Voltage", "Design Capacity Warning", "Design Capacity Low",
      "Capacity Granularity 1", "Capacity Granularity 2", "Model Number",
      "Serial Number", "Battery Type", "OEM Info"},
     {"/proc/acpi/battery/BAT0/info", "present", "design capacity", "last full capacity",
      "battery technology", "design voltage", "design capacity warning", "design capacity low",
      "capacity granularity 1", "capacity granularity 2", "model number",
      "serial number", "battery type", "OEM info"}};
  char* batt_state_strs[][7]=
    {{"/proc/acpi/battery/BAT0/state", "Present", "", "State", "Present Rate",
      "Remaining Capacity", "Battery Voltage"},
     {"/proc/acpi/battery/BAT0/stat", "present", "capacity state", "charging state",
      "present rate", "remaining capacity", "present voltage"}};

int iupdate;
QString error,systemtray,systemtray_tmp;
KConfig* config = kapp->config();
iupdate = config->readNumEntry("Update", 0);
QString sfull = config->readEntry("icon_full", "mini_ackacpi.png");
QString sdischarging = config->readEntry("icon_discharging", "");
QString scharging = config->readEntry("icon_charging", "");
QString sdrawbeam = config->readEntry("drawbeam", "true");
QString sbattery2ak = config->readEntry("Batt2", "0");
bool aown = config->readBoolEntry("Aown", false);
bool debug = config->readBoolEntry("debug", false);

if (! strcmp(sbattery2ak ,"false") )
 {
  btab_[2]->setEnabled(FALSE);
 }
else
 {
  btab_[2]->setEnabled(TRUE);
 }
  mini_ac     = SmallIcon(sfull,24);
  mini_batt   = SmallIcon(sdischarging,24);
  mini_acload = SmallIcon(scharging,24);
  icon        = mini_batt;



if (iupdate == 1 )
 {
 ifstream acpi_s("/proc/acpi/info");
 while(acpi_s)
 {
  getline(acpi_s, zeile);
  int pos = zeile.find(":");
  if (pos > 0) {
    key =zeile.substr(0,pos);
    istringstream is(zeile.substr(pos+1).c_str());
    is >> value;
    acpi_f[key] = value;
    }
  }
acpi_s.close();
if (acpi_f["ACPI-CA Version"].c_str()[0] != '\0')
  {
  acpi_ver=0; // alte Version
    if (debug)
     {
       cerr << "Acpi Version < 20020404\nACPI: " << acpi_f["ACPI-CA Version"] << endl;
     }
  }
else if (acpi_f["version"].c_str()[0] != '\0')
{
 acpi_ver =1;  // neue Version
       if (debug)
     {
       cerr << "Acpi Version > 20020404\nACPI: " << acpi_f["version"] << endl;
     }
}
else
{
 // acpi_ver=3;
  if (debug)
   {
    cerr << "Acpi: Could not indicate your acpi-version. Please write an email to jonasge@gmx.net With all the output." << endl;
   }
}
//user pfade
if (aown)
{
 if (debug) { cerr <<"ACPI: use own paths.."<< endl; }
}

if (debug)
 {
  cerr << "Acpi-V-int: " << acpi_ver << "\nBattery: "<< battery << endl;
 }


if (acpi_ver == 0)
  {
    if (battery == 0)
     {
      fbat_state="/proc/acpi/battery/1/state";
      fbat_info="/proc/acpi/battery/1/info";
      fac_state="/proc/acpi/ac_adapter/0/state";
       if (debug) { cerr << "ACPI-V == 0\nBattery == 0"<< endl; }
     }
   else
     {
      fbat_state="/proc/acpi/battery/2/state";
      fbat_info="/proc/acpi/battery/2/info";
      fac_state="/proc/acpi/ac_adapter/0/state";
       if (debug) { cerr << "ACPI-V == 0\nBattery == 1"<< endl; }
     }

 }

else if (acpi_ver == 1)
{
  if (battery ==0)
   {
    fbat_state="/proc/acpi/battery/BAT0/state";
    fbat_info="/proc/acpi/battery/BAT0/info";
    fac_state="/proc/acpi/ac_adapter/ACAD/state";
     if (debug) { cerr << "ACPI-V == 1\nBattery == 0"<< endl; }
   }
  else
  {
   fbat_state="/proc/acpi/battery/BAT1/state";
   fbat_info="/proc/acpi/battery/BAT1/info";
   fac_state="/proc/acpi/ac_adapter/ACAD/state";
    if (debug) { cerr << "ACPI-V == 1\nBattery == 1"<< endl; }
  }

 }




if (aown) //eigende Pfade benuetzen
 {
  static QString facstate;
  static QString fbatstate;
  static QString fbatinfo;
   facstate= config->readEntry("ACFile","/proc/acpi/ac_adapter/ACAD/state");
   fbatstate=config->readEntry("StatusFile", "/proc/acpi/battery/BAT0/state");
   fbatinfo=config->readEntry("InfoFile", "/proc/acpi/battery/BAT0/info");
   if (battery ==1) // 1
    {
      if (fbatstate.contains('0', FALSE )==1)
       {
         fbatstate.replace(QRegExp("0"), "1");
       }
      else
       {
        fbatstate.replace(QRegExp("1"), "2");
       }

      if (fbatinfo.contains('0', FALSE )==1)
       {
        fbatinfo.replace(QRegExp("0"), "1");
       }
      else
       {
        fbatinfo.replace(QRegExp("1"), "2");
       }

    }// battery ==1

fac_state=facstate.ascii();
fbat_state=fbatstate.ascii();
fbat_info=fbatinfo.ascii();



}
if (debug)
{
cerr << "ACPI Version: " << acpi_ver << endl;
cerr << "Fbat_state: " << fbat_state << endl << "Fbatinfo: " << fbat_info << endl << "Fac: " << fac_state << endl;
}
// ============================================
// AC state auslesen:
ifstream ac_s(fac_state);
if (ac_s)
{
 while(ac_s)
 {
  getline(ac_s, zeile);
  int pos = zeile.find(":");
  if (pos > 0) {
    key =zeile.substr(0,pos);
    istringstream is(zeile.substr(pos+1).c_str());
    is >> value;
    ac_f[key] = value;
    }
  }
ac_s.close();
}
else
{
error = i18n("Error could not open \n") + fac_state + i18n(" for reading the AC-Adapter informationen.\nPlease open the Settingsdialog and check your path.");
QMessageBox::critical(this,i18n("Kacpi - Error"), error);
}


// ============================================
// BAT state auslesen:
ifstream bat_state_s(fbat_state);
if (bat_state_s)
{
 while(bat_state_s)
 {
  getline(bat_state_s, zeile);
  int pos = zeile.find(":");
  if (pos > 0) {
    key =zeile.substr(0,pos);
    istringstream is(zeile.substr(pos+1).c_str());
    is >> value;
    bat_state_f[key] = value;
    }
  }
bat_state_s.close();
}
else
{
error = i18n("Error could not open \n") + fbat_state + i18n(" for reading the battery informationen.\nPlease open the Settingsdialog and check your path.");
QMessageBox::critical(this,i18n("Kacpi - Error"), error);
}


// ============================================
// BAT info auslesen:
ifstream bat_info_s(fbat_info);
if (bat_info_s)
{
while(bat_info_s)
{
 getline(bat_info_s, zeile);
 int pos = zeile.find(":");
 if (pos > 0) {
   key =zeile.substr(0,pos);
   istringstream is(zeile.substr(pos+1).c_str());
   is >> value;
   bat_info_f[key] = value;
   }
}
bat_info_s.close();
}
else
{
error = i18n("Error could not open \n") + fbat_info + i18n(" for reading the battery informationen.\nPlease open the Settingsdialog and check your path.");
QMessageBox::critical(this,i18n("Kacpi - Error"), error);
}

if (debug) { cerr << "After reading the files."<< endl; }
// werte angeben usw...
// wenn present = no dann update nicht
if(strcmp( (bat_state_f[batt_state_strs[acpi_ver][1]].c_str()), "no"))
{ // present = no
if (debug) { cerr << "In Present == yes" << endl; }
// Battery status angeben       anfang
if (debug) { cerr << "Battery state: "<< bat_state_f[batt_state_strs[acpi_ver][3]].c_str()<< endl; }
if   (!strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "ok") || !strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "unknown"))
{
linetime_[battery]->setText(i18n(""));
linestatus_[battery]->setText(i18n("Battery is full."));
icon = mini_ac;
systemtray = i18n("Battery is full.");
if (debug) { cerr << "Battery state == ok or unknown" << endl; }
}
else if (!strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "charging"))
{
linestatus_[battery]->setText(i18n("Battery is charging."));
icon = mini_acload;
systemtray = i18n("Battery is charging.");
if (debug) { cerr << "Battery state == charging" << endl; }
}
else if (!strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "discharging"))
{
 linestatus_[battery]->setText(i18n("Battery is discharging."));
 icon = mini_batt;
 systemtray = i18n("Battery is discharging.");
if (debug) { cerr << "Battery state == discharging" << endl; }
}
else
{
cerr << "Battery state == ???, Couldn't indicate a state of your battery!" << endl;
}
// battery status angeben ENDE
if (debug)  { cerr << "After Battery state..."<< endl; }
// Ladestatus in %-Ausgeben Anfang
ladestatus_double = (atof(bat_state_f[batt_state_strs[acpi_ver][5]].c_str())) / (atof(bat_info_f[batt_info_strs[acpi_ver][3]].c_str())) *100;
lcdnumber_[battery]->display(ladestatus_double);
systemtray += " ";
systemtray_tmp.sprintf("%d", (int)ladestatus_double);
systemtray += systemtray_tmp;
systemtray += "  %";
// Ladestatus in %-Ausgeben ENDE
if (debug) { cerr << "Powerstate: "<< ladestatus_double << endl; }

char_laufzeit[0]='\0';
// Laufzeit discharging ausgeben: Anfang
if (!strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "discharging") || !strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "charging"))
{
if (debug) {  cerr << "In discharging and charging selction"<< endl; }
laufzeit_double  =0;
char_laufzeit[0]='\0';
    // if(!strcmp(bat_state_f[batt_state_strs[acpi_ver][4]].c_str(),"unknown"))
   //  bat_state_f[batt_state_strs[acpi_ver][4]]="2000"; // DIRTY Hack fr Hartwig

//wenn kein present rate, dann bringe QMessageBox:
 if (!strcmp(bat_state_f[batt_state_strs[acpi_ver][4]].c_str(), "unknown") || !strcmp(bat_state_f[batt_state_strs[acpi_ver][4]].c_str(), "0"))
   {
    bat_state_f[batt_state_strs[acpi_ver][4]]="3000";
    if (!config->readBoolEntry("presentRATE", false))
     {
       QMessageBox::warning(this, "Can't find the present rate", "Can't find the present rate in your files.\nI will set the present rate to 3000\nIt is not right, but after this you have a value.\nPlease write an email to jonasge@gmx.net\nThanks....");
       config->writeEntry("presentRATE", "true");
       config->sync();
      }
    if (debug)
     {
      cerr << "Can't find the present rate in your files....\nSetting the present rate to 3000\nPlease note the values now not right...\n"<< endl;
     }
   }
//kein present rate ende.

if (!strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "discharging"))
{
laufzeit_double  = 3600 * (atof(bat_state_f[batt_state_strs[acpi_ver][5]].c_str())) / (atof(bat_state_f[batt_state_strs[acpi_ver][4]].c_str()));
}
else
{
laufzeit_double = 3600 * ((atof(bat_info_f[batt_info_strs[acpi_ver][2]].c_str())) - (atof(bat_state_f[batt_state_strs[acpi_ver][5]].c_str()))) / (atof(bat_state_f[batt_state_strs[acpi_ver][4]].c_str()));
}
sec = (int)laufzeit_double;
hour = sec / 3600;
sec -= 3600 *  hour;
minn = sec / 60;
sec -= 60 * minn;

if ( ! strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "discharging"))
{
  // discharging dranhngen
  sprintf(char_laufzeit, i18n("0%d:%02d:%02d remaining"), hour,minn,sec);
  if (hour == 0 && minn < 5)
   {
    battery_state =true;
     if (debug) { cerr << "In batery_state == true (min < 5)" << endl; }
   }
  else
   {
    battery_state=false;
     if (debug) { cerr << "In batery_state == false (min > 5)" << endl; }
   }
}
else
{
 //charging dranhngen
 sprintf(char_laufzeit, i18n("0%d:%02d:%02d until charged"), hour,minn,sec);
}

linetime_[battery]->setText(char_laufzeit);
systemtray += " \n";
systemtray += char_laufzeit;

}
else
{
// Box leeren.
linetime_[battery]->setText("");
}
// Laufzeit discharging ausgeben: ENDE


} // present = no
else
{
 linetime_[battery]->setText("");
 linestatus_[battery]->setText(i18n("No Battery installed."));
 lcdnumber_[battery]->display(0);
 icon = mini_ac;
 ladestatus_double=0;
  if (debug) {  cerr << "Present == no\nNo Battery installed"<< endl; }
}//presen = no

// AC-adapter online ? Anfang
if (! strcmp((ac_f[ac_state_strs[acpi_ver][1]].c_str()), "on-line"))
{
  ledac_1->setColor(green);
  ledac_2->setColor(green);
  ac_status=true;
}
else
{
  ledac_1->setColor(red);
  ledac_2->setColor(red);
  ac_status=false;
}
// AC-Adapter online ENDE

if ( ! strcmp( (bat_state_f[batt_state_strs[acpi_ver][3]].c_str()), "discharging"))
{
  if (debug) { cerr << "Discharging deshalb: slotbat() " << endl; }
  slotlowbat((int)ladestatus_double, ac_status, battery_state)  ;
}


  if (battery == 0)
   {
    QPainter paint(&icon);
     if (! strcmp(sdrawbeam, "true"))
      {
      
 	if(!config->readBoolEntry("Batt2", false))
	 { 
	  beam = (int)(0.2 *(int)ladestatus_double);
	  hoehe = 20 - beam +2;
	  paint.drawRect(2,2,3,20);
	  paint.fillRect(2,hoehe,3,beam , green);   
	 }
	 else
	 {     
          beam  = (int)(0.2 * (int)ladestatus_double) ;
          hoehe = (20 - beam) +2 ; // !??!
          paint.drawRect(2,2,3,20);
          paint.fillRect(2,hoehe,3,beam , red);
	 }
      }
  // System Tray Ausgeben:
  ksdock->setPixmap(icon);
  QToolTip::remove(ksdock);
  QToolTip::add(ksdock, systemtray);
  systemtray="";
   }
 else
  {

    if (! strcmp(sdrawbeam, "true"))
     {
       curicon = ksdock->pixmap();
       QPainter paint(curicon);
       beam  = (int)(0.2 * (int)ladestatus_double) ;
       hoehe = (20 - beam) +2 ; // !??!
       paint.drawRect(17,2,18,20);
       paint.fillRect(17,hoehe,18,beam , red);
     }

  }// if battery==0



 } // if (iupdate == 0 ) ENDE



 if (debug)  {  cerr << "\nUpdate function end...........\n"<<endl; }
}
//=============================================================================
//                  ENDE ENDE ENDE Update slot
//==============================================================================


void kacpi::slotExit()
 {
    realclosing=true;
    close();
 }


void kacpi::slottimer()
 {
 int itime;
 KConfig* config = kapp->config();
 itime = config->readNumEntry("Autoupdate", 60);
 itime = itime * 1000;
 QTimer::singleShot( itime, this, SLOT(slottimer2()));
 }

void kacpi::slottimer2()
{
slotreload();
slottimer();
}

void kacpi::slotnewconf()
 {
   newconf *dlg = new newconf;
   dlg->show();
 }

void kacpi::slotreload()
{
slottmp();
slotbattery_1(0);
KConfig* config = kapp->config();
buffer = config->readBoolEntry("Batt2", false);
if (buffer)
 {
 slotbattery_1(1);
 }

}



void kacpi::slottmp()
{
FILE *thermal;
char cname[80], char_tmp[80], char_tmpf[80]="Error: No CPU Temp!";
QString stempfile,sthermal;

KConfig* config = kapp->config();
stempfile = config->readEntry("tempfile", "");
buffer  = config->readBoolEntry("temp", false);

if (buffer)
{

if (( thermal = fopen(stempfile, "r")) != NULL)  // Thermal file
    {
      fscanf(thermal, "%s%s", cname,char_tmp);
      fclose(thermal);
      sprintf(char_tmpf, i18n("CPU Temperature: %s C"), char_tmp);
      QString scputemp="";
	scputemp= char_tmp;
	scputemp+="  C";
	licputemp->setText(scputemp);
    }
  else
     {
     QMessageBox::critical(this, i18n("Error: CPU temperature"), i18n("Could not open the temperature proc file.\nPlease go to the configuration dialog and check the settings.\n"));
     }

kbar = statusBar();
kbar->changeItem(char_tmpf, 0);
} // temp == true ?
}

void kacpi::slotlowbat(int prozent, bool ac_status, bool battery_state)
{

//printf("\nProzent: %d\n", prozent);
KConfig* config = kapp->config();
bool waraktive = config->readBoolEntry("waraktive", false);
bool showmsg   = config->readBoolEntry("showmsg", true);
bool playsound = config->readBoolEntry("playsound", false);
bool execommand = config->readBoolEntry("execommand", false);
QString warcommand = config->readEntry("warcommand", "");
QString warsound = config->readEntry("warsound", "");
bool warlowak = config->readBoolEntry("warlowak", false);

if (waraktive)
{
//printf("Waraktive\n");
if (prozent > 8 && prozent < 13 )
 {
// printf("Innerhalb von 10-12 prozent\n");
 if (!warlowak)
  {
   config->writeEntry("warlowak", "true");
   config->sync();
//   printf("WarLoak == false drin\n");
   // Anfang warnung ausgeben...
   if (playsound)
    {
        if (!warsound.isEmpty())
         {
           KAudioPlayer::play(warsound);
         }
    }

  if (execommand)
    {
      KProcess command;
      command << warcommand;
       if (!command.start(KProcess::DontCare))
       {
        static QMessageBox cne_mb("Critical", i18n("Sorry, the program that I should start for you failed to start!"),QMessageBox::Critical,QMessageBox::Ok|QMessageBox::Default,QMessageBox::NoButton,QMessageBox::NoButton, this, "kacpi", false);
        cne_mb.show();
       }
    }


    if (showmsg)
      {

         static QMessageBox msg_box("Warning", i18n("Battery power is very low.\nPlease connect the AC-Adapter to your laptop soon."),QMessageBox::Warning,QMessageBox::Ok|QMessageBox::Default,QMessageBox::NoButton,QMessageBox::NoButton, this, "kacpi", false);
         msg_box.show();
      }

// Ende warnung ausgeben....

  }//warlock

 }
else
 {
 config->writeEntry("warlowak", "false");
// printf("Warlowak == false\n");
 config->sync();
 }

if (config->readBoolEntry("shutdownpc", "false"))
{ // shtudown ?
if (! ac_status)
 {

  if (battery_state)
    {
        // QMessageBox wenn user = cancel, dann cancel shtdown, wen nach 15 sec nix passiert, dann shutdown pc.
        // QMessageBox Cancel und wenn OK klick, dann sofort shutdown.

QTimer::singleShot( 30000, this, SLOT(slotshutdown())); //30 sec keine Ahnung.
QMessageBox shut("Critical", i18n("Battery power is very low.\nPlease connect AC Adapter to your latop soon.\nOtherwise kacpi will automatically shutdown your laptop in 30sec."),QMessageBox::Critical,QMessageBox::Ok|QMessageBox::Default,QMessageBox::Cancel|QMessageBox::Escape,QMessageBox::NoButton,  this,"kacpi", true);
switch(shut.exec())
 {
  case QMessageBox::Ok:
  canceled=true;
  cerr << "QMessageBox OK  :    " <<endl;
  realshutdown();
  break;

  case QMessageBox::Cancel:
  canceled=true;
  cerr << "QMessageBox Cancel    :    "<< endl;
  //mache nix.
  break;
 }

    }
 }
}//shutdown ?



} // waraktive == true ?



} // slotlowbat ende


// ===================================================
void kacpi::slotshutdown()
{

cerr << "Shutdown SLOT  :   "<< endl;
if (! canceled)
 {
  // shutdown befehl.
   realshutdown();
   cerr << "SHUTDOWN NOW"<< endl;

 }
}

void kacpi::realshutdown()
{
  KApplication b;
  b.requestShutDown(KApplication::ShutdownConfirmNo,KApplication::ShutdownTypeHalt,KApplication::ShutdownModeForceNow);

}

void kacpi::closeEvent(QCloseEvent *e)
{

KConfig* config = kapp->config();
if (config->readBoolEntry("dock_panel", false))
 {
if (!realclosing)
 {
  e->ignore();
  hide();
 }
 else
 {
 e->accept();
 }
 }
else
{
 e->accept();
}
}

void kacpi::slotproc()
 {
   procviewer *dlg = new procviewer;
   dlg->show();
 }

void kacpi::slotcputimer()
{
  QTimer::singleShot( 1000, this, SLOT(cpufreq()));
}


/*
This code is from autospeedstep-0.2
I have mod it for kacpi.
Copyright (c) 2002 Fritz Ganter <ganter@ganter.at>
Website: http://gpsdrive.kraftvoll.at
Speedstep is a daemon for linux kernel using ACPI which controls the
CPU speed on SpeedStep CPUs depentend of the CPU load
*/

void kacpi::cpufreq()
{
 FILE *fp;
 int e;
 unsigned int cuse, cice,  csys ;
 int load;
 unsigned long cide;
 int highval=70;
 int lowval=20;
 KConfig* config = kapp->config();
 int cpucheck = config->readNumEntry("CPU_FILE", 0);
 if ((fp = fopen("/proc/stat", "r")))
  {
    do
     {
      e = fscanf (fp, "cpu  %u %u %u %lu", &cuse, &cice, &csys, &cide);
     }
    while( e != 4);
    if (oldcuse !=0)
     {
      load = cuse +csys - oldcuse;
      lcdcpuload->display(load);
      cout << "LOAD: "<< load<< endl;
       if (load > highval)
         {
	  cout << "CPU UP"<< endl;
	  if (oldstatecpu != 1)
	   {
	    if (cpucheck==0)
	     {
	      system("kasetperm 0 up");
	     }
	     else
	      {
	      system("kasetperm 0 up");
	      }
	    licpuspset->setText("Yes (Up)");
	    cout << "Change cpufreq -> up"<< endl;
	   }
	  oldstatecpu=1;
	 }
       if ( load < lowval)
        {
	 cout << "CPU DOWN"<< endl;
	  if (oldstatecpu != 2)
	   {
	   if (cpucheck==0)
	    {
	     system("kasetperm 0 down");
	    }
	    else
	    {
	    system("kasetperm 1 down");
	    }
	    licpuspset->setText("Yes (Down)");
	    cout << "Change cpufrew -> down"<< endl;
	   }
	  oldstatecpu=2;
	}

      } // if oldcuse != 0
      oldcuse = cuse +csys;
      fclose(fp);

  } // if fopen != NULL
   slotcputimer();
}
/*
autospeedstep code end.
*/


void kacpi::checkforcpu()
{
QString error;
map<string, string> cpucheck_f;
map<string, string> cpu_f;
string zeile;
string key;
string value;
string key_neu;
int cpucheck_id=0;
int cpufreq=0;
int throttling=0;
QString key_q;
char* cpucheck_strs[][3]={{"/proc/acpi/processor/CPU/info", "throttling control", "performance management"}, {"/proc/acpi/processor/CPU0/info", "throttling control", "performance management"}};
  if(fopen("/proc/acpi/processor/CPU/info", "r")!=NULL)
   {
    cpucheck_id=0;
    cerr << "INFO: SET cpucheck to 0:  /proc/acpi/processor/CPU/info "<< endl;
   }
  else if(fopen("/proc/acpi/processor/CPU0/info", "r")!=NULL)
   {
     cpucheck_id=1;
     cerr << "INFO: SET cpucheck to 1:  /proc/acpi/processor/CPU0/info "<< endl;
   }
  else
   {
   cerr << "Error: Konnte kein CPU FILE finden."<< endl;
   }

  ifstream cpucheck_s(cpucheck_strs[cpucheck_id][0]);
  if (cpucheck_s)
  {
    while(cpucheck_s)
     {
      getline(cpucheck_s, zeile);
      int pos = zeile.find(":");
      if (pos > 0) {
        key =zeile.substr(0,pos);
        istringstream is(zeile.substr(pos+1).c_str());
        is >> value;
        cpucheck_f[key] = value;
      }
     }// while endle
  cpucheck_s.close();
  }
 else
  {
  
 // error = i18n("Error could not open \n") + cpucheck_strs[cpucheck_id][0] + i18n(" for reading the AC-Adapter informationen.\nPlease open the Settingsdialog and check your path.");
 // QMessageBox::critical(this,i18n("Kacpi - Error"), error);
 cout << "KACPI ERROR: Could not open "<<cpucheck_strs[cpucheck_id][0] << "for reading"<< endl;
  }// esle ende

  //checke die Werte in dem Infos file:
  if((strcmp(cpucheck_f["performance management"].c_str(), "yes"))==0)
   {
    cpufreq=1;
    cerr << "INFO: CPU FREQ is avaiable. Setting CPU_FREQ=1"<< endl;
   }
   else
    {
    cpufreq=0;
    cerr << "INFO: CPU FREQ is NOT avaiable. Setting CPU_FREQ=0"<< endl;
    }

   if ((strcmp(cpucheck_f["throttling control"].c_str(), "yes"))==0)
   {
    throttling=1;
    cerr << "INFO: Throttling is avaiable. Setting throttling=1"<< endl;
   }
   else
   {
   throttling=0;
   cerr << "INFO: Throttling is NOT avaiable. Setting throttling=0"<< endl;
   }
// Write to conf File:
KConfig* config = kapp->config();
config->writeEntry("CPU_AVA", "1");
config->writeEntry("CPU_FILE", cpucheck_id);
config->writeEntry("CPU_FREQ",cpufreq);
config->writeEntry("CPU_THRO", throttling);
config->sync();

// ENDE Write to Conf file
// READ what CPU is
ifstream cpu_s("/proc/cpuinfo");
if (cpu_s)
{
 while(cpu_s)
 {
  getline(cpu_s, zeile);
  int pos = zeile.find(":");
  if (pos > 0) {
    key_q =zeile.substr(0,pos).c_str();
    value = zeile.substr(pos+1).c_str();
    key_q =  key_q.stripWhiteSpace();
    key_neu = key_q.ascii();
    cpu_f[key_neu] = value;
    }
  }
cpu_s.close();
licpu->setText(cpu_f["model name"].c_str());
}
else
{
cerr << "Error: Can't open file /proc/stat for R"<< endl;
}
// ENDE READ CPU



}// ende checkforcpu










