 /***************************************************************************
                          procviewer.cc -
                             -------------------
    begin                : Fri Dec 27  22:22:11 CET 2002
    copyright            : (C) 2002,2003 by Jonas Genannt
    email                : jonasge@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//QT      include:
#include <qmessagebox.h>
#include <qdir.h>
//KDE     include:
#include <klocale.h>
#include <kconfig.h>
//other   include:
#include "procviewer.moc"
#include <iterator>
#include <string>
#include <sstream>
#include <fstream>
#include <map>

using namespace std;

procviewer::procviewer( QWidget *parent,const char *name,bool modal )
    : QDialog(parent, name,modal)
 {
anzahl=0;
   QFont fdefault("Helvetica", 10);
   this->resize(540,430);// 640,530
   this->setMinimumSize(0,0);
   this->setCaption(i18n("ProcViewer"));

   maintab = new QTabWidget(this,"maintab");
   maintab->setGeometry(QRect(20,30,500,390));


slotreadfiles("/proc/acpi/");
for (int e=0; e<anzahl;e++)
 {
// cerr << "Filename: "<<filenamen[e]<< endl;
 if (!strcmp(filenamen[e], "/proc/acpi/dsdt")|| !strcmp(filenamen[e], "/proc/acpi/event")|| !strcmp(filenamen[e], "/proc/acpi/fadt")|| !strcmp(filenamen[e], "/proc/acpi/sleep"))
  {  } else
  {
  slotreadfile(e, filenamen[e]);
  }
 }//for-schleife
}

procviewer::~procviewer()
{

}

void procviewer::slotsetview(int number, char * filename)
 {
  tab_[number] = new QWidget(maintab, "tab_[number]");
  maintab->insertTab(tab_[number], filename);
  label_[number] = new QLabel(tab_[number], "");
  label_[number]->setGeometry(20,15,460,20);
  label_[number]->setText(filename);
  label_[number]->setAlignment( int( QLabel::AlignCenter ) );

  listview_[number] = new KListView(tab_[number]);
  listview_[number]->setGeometry(20,40,460,310);
  listview_[number]->setSorting(0, true);
  listview_[number]->setAllColumnsShowFocus( TRUE );
  listview_[number]->addColumn("Name");
  listview_[number]->addColumn(" ");
  listview_[number]->addColumn("Value");
  listview_[number]->setColumnWidth(0,150);
  listview_[number]->setColumnWidth(1, 55);
  listview_[number]->setColumnWidth(2,245);

 }


void procviewer::slotreadfile(int number, char *filename)
 {
 map<string, string> file_map;
 string zeile;
 string key;
 QString value;


ifstream file(filename);
if (file)
{
//create TAB:
slotsetview(number,filename);
 while(file)
 {
  getline(file, zeile);
  int pos = zeile.find(":");
   if (pos > 0) {
    key =zeile.substr(0,pos);
    value = zeile.substr(pos+1).c_str();
    value = value.stripWhiteSpace();
   listview_[number]->insertItem(new KListViewItem(listview_[number], key.c_str(),":", value));
   }
 }
file.close();
}
else
 {
//   QMessageBox::warning(this, "ProcViewer: Error", "Could not open\n"+filename+" for reading!!");
 }
}//ende readfile


void procviewer::slotreadfiles(QString readindir)
 {

  QDir dir = QDir::root();
 if (!dir.cd(readindir))
    { 
      cerr << "No "<< readindir <<" exists!"<< endl;
      QMessageBox::warning(this, "ProcViwer: Error", "Error:\nNo"+readindir+" exists.");
    }
 dir.setFilter(QDir::Files);
 const QFileInfoList *list = dir.entryInfoList();
 QFileInfoListIterator it(*list);
 QFileInfo *fi;
 while ( (fi=it.current()) !=0)
  {
   static QString filename;
   filename=dir.path()+"/"+fi->fileName();
 //  cerr << "Filename: "<<filename<< endl;
   sprintf(filenamen[anzahl], "%s", filename.ascii());
   anzahl++;
   ++it;
  }
 dir.setFilter(QDir::Dirs);
  const QFileInfoList *listd = dir.entryInfoList();
 QFileInfoListIterator itd(*listd);
 QFileInfo *fid;
 while ( (fid=itd.current()) !=0 )
  {
   if (fid->fileName()!= ".")
    {
      if (fid->fileName()!="..")
      {
       QString indir = dir.path()+"/"+fid->fileName();
     //  cerr << "Dir: "<< indir<< endl;
       slotreadfiles(indir);
      }
    }

   ++itd;
  }
//cerr << "\nAnzahl der datein: "<< anzahl << endl;
 }

void procviewer::closeEvent(QCloseEvent *e)
 {

 anzahl=0;
 for (int f=0;f<41;f++)
  {
   filenamen[f][0]='\0';
  }
 e->accept();
 }
